#!/usr/bin/python

#Recuperation valeurs Luxtronic Alpha Innotec
#par Maxime Princelle
#---------------------------------------------

import socket
import struct
import sys
import datetime
import httplib

######################################################

# Luxtronik 2.0 IP
hostHeatpump = '192.168.0.12'
# Luxtronik 2.0 port (standard 8888)
portHeatpump = 8888

######################################################

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((hostHeatpump, portHeatpump))

######################################################

s.send(struct.pack( '!i', 3004))
s.send(struct.pack( '!i', 0))

if struct.unpack('!i', s.recv(4))[0] != 3004:
	print(" Error: REQ_CALCULATED CMD ")
	exit()

stat = struct.unpack( '!i', s.recv(4))[0]
len = struct.unpack( '!i', s.recv(4))[0]
array_calculated = []

#print(array_calculated)

for i in range(len):
	array_calculated.append(struct.unpack( '!i', s.recv(4))[0])
	#print ('Calculated')
	#print (stat)
	#print (len)
	#print (array_calculated)
	#print ('\n\n')


if sys.argv[1]=='tempext':
	#Temperatuur buiten
	#Temperature exterieur
	#Unite : degre Celsius
	print(str(float(array_calculated[15])/10))

if sys.argv[1]=='tempgaz':
	#Temperature gaz
	#Unite : degre Celsius
	print(str(float(array_calculated[14])/10))

if sys.argv[1]=='tempentr':
	#Temperatuur voorloop
	#Temperature entree
	#Unite : degre Celsius
	print(str(float(array_calculated[10])/10))

if sys.argv[1]=='tempretour':
	#Temperatuur naloop
	#Temperature retour
	#Unite : degre Celsius
	print(str(float(array_calculated[11])/10))

if sys.argv[1]=='consretour':
	#Rucklauf Soll
	#Consigne Retour
	#Unite : degre Celsius
	print(str(float(array_calculated[12])/10))

if sys.argv[1]=='tempairent':
	#WQ Eingangstemp
	#Temperature Air Entree
	#Unite : degre Celsius
	print(str(float(array_calculated[19])/10))

if sys.argv[1]=='tempairavg':
	#Temperature Air Moyenne
	#Unite : degre Celsius
	print(str(float(array_calculated[16])/10))

if sys.argv[1]=='tempairsor':
	#WA Ausgangstemp
	#Temperature Air Sortie
	#Unite : degre Celsius
	print(str(float(array_calculated[20])/10))

if sys.argv[1]=='timefonct':
	#Betriebszeit Verdichter 1
	#Temperature fonctionnement cumul
	#Unite : Temps
	print(str(datetime.timedelta(seconds=int(array_calculated[56]))))

if sys.argv[1]=='nbstart':
	#Impulse VD1
	#Nb de start
	#Unite : Compteur
	print(str(array_calculated[57]))

if sys.argv[1]=='8':
	#Verbruik verwaming (kWh)
	#?
	#Unite : kWh
	print(str(float(array_calculated[151])/10))

if sys.argv[1]=='timeon':
	#Betriebsstunden WW Erzeugung
	#Temps marche
	#Unite : Temps
	print(str(datetime.timedelta(seconds=int(array_calculated[65]))))

if sys.argv[1]=='10':
	#Verbruik heet water (kWh)
	#?
	#Unite : kWh
	print(str(float(array_calculated[152])/10))

if sys.argv[1]=='11':
	#Status Zeile 1 (code)
	#?
	#Unite : Binaire
	print(str(array_calculated[117]))

if sys.argv[1]=='12':
	#Status Zeile 2 (code)
	#?
	#Unite : Binaire
	print(str(array_calculated[118]))

if sys.argv[1]=='13':
	#Status Zeile 3 (code)
	#?
	#Unite : Binaire
	print(str(array_calculated[119]))

if sys.argv[1]=='timeoff':
	#Status seit :
	#Temps arret
	#Unite : Temps
	print(str(datetime.timedelta(seconds=int(array_calculated[120]))))

if sys.argv[1]=='15':
	#WMZ Durchfluss L/h
	#?
	#Unite : L/h
	print(str(float(array_calculated[155])))

##############################################

conn = httplib.HTTPConnection("192.168.0.12:8888") #changer avec l'adresse ip et le port (comme en haut)
conn.request("HEAD","/json.htm?type=command&param=udevice&idx=191&svalue=" + (str(float(array_calculated[151])*100)))
#res = conn.getresponse()
#print(res.status, res.reason)

###############################################

s.close()